import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class AreaDesenho extends JPanel
{
    Aplicacao aplic; // ref. para aplicao principal
    Point pontos[] = new Point[100];
    int total;

    // Construtor - recebe uma referncia para a aplicao, para que
    // seja possvel chamar o mtodo atualizaCont(..), que atualiza
    // o contador de pontos na tela
    public AreaDesenho(Aplicacao aplic,int w,int h)
    {
        // Inicializa o JPanel, atravs do construtor da superclasse
        super();

        // Armazena a ref. para a Aplicao
        this.aplic = aplic;

        setPreferredSize(new Dimension(w,h)); // seta o tamanho desejado

        // Adiciona um mouse listener, atravs de uma classe interna
        // annima, extendendo MouseAdapter
        addMouseListener(
          new MouseAdapter()
          {
            // mousePressed - pressionar e soltar o boto do mouse
            public void mousePressed(MouseEvent e)
            {
                novoPonto(e.getX(),e.getY());
            }
          });

        // Zera o total de pontos
        total = 0;
    }

    // Este mtodo  responsvel por atualizar o painel - nunca deve
    // ser chamado diretamente, quem o ativa  o sistema operacional
    // Recebe uma referncia para "Graphics", que  a classe que
    // oferece diversos mtodos para desenho - consulte os docs!
    public void paintComponent(Graphics g)
    {
        // O mtodo paintComponent(..) da superclasse (JFrame)
        // serve apenas para pintar o fundo - experimente comentar e
        // veja o que acontece...
        super.paintComponent(g);
        // Seta a cor para traado
        // "Color"  uma classe que armazena constantes de cor - veja
        // a documentaao!
        g.setColor(Color.blue);
        // Desenha cada ponto como uma oval de raio = 10
        for(int i=0;i<total;++i)
           g.drawOval(pontos[i].x-5,pontos[i].y-5,10,10);       
    }

    // Adiciona um novo ponto ao array
    public void novoPonto(int x, int y)
    {
        int c;
        if(total==100) return;
        pontos[total] = new Point(x,y);
        total++;
        aplic.atualizaCont(total);
        // repaint()  o mtodo para atualizar a tela
        // chama implicitamente paintComponent(...)
        repaint();
    }
}